class Operator {
	name: string;
	gender: Gender;
	side: Side;
	roles: Array<Role>;
	speed: number;
	squad: Squad;

	constructor(name: string, gender: Gender, side: Side, roles: Array<Role>, speed: number, squad: Squad) {
		this.name = name;
		this.gender = gender;
		this.side = side;
		this.roles = roles;
		this.speed = speed;
		this.squad = squad;
	}
}

enum Gender {
	male,
	female,
	divers
}

enum Side {
	attacker,
	defender
}

enum Squad {
	Rainbow,
	Nighthaven,
	Wolfguard,
	Ghosteyes
}

enum Role {
	Intel_Gatherer,
	Area_Denial,
	Covering_Fire,
	Crowd_Control,
	Anchor,
	Secure,
	Anti_Roam,
	Roam,
	Buff,
	Soft_Breach,
	Disable,
	Back_Line,
	Intel_Denier,
	Front_Line,
	Hard_Breach,
	Flank,
	Trap,
	Anti_Hard_Breach,
	Shield
}

const operators: Array<Operator> = [
	new Operator('Solid', Gender.female, Side.defender, [Role.Intel_Gatherer], 2, Squad.Ghosteyes),
	new Operator('Grim', Gender.male, Side.attacker, [Role.Intel_Gatherer, Role.Area_Denial], 3, Squad.Nighthaven),
	new Operator('Sens', Gender.divers, Side.attacker, [Role.Covering_Fire, Role.Area_Denial, Role.Crowd_Control], 3, Squad.Wolfguard),
	new Operator('Azami', Gender.female, Side.defender, [Role.Area_Denial], 2, Squad.Rainbow),
	new Operator('Thorn', Gender.female, Side.defender, [Role.Anchor, Role.Secure], 2, Squad.Rainbow),
	new Operator('Osa', Gender.divers, Side.attacker, [Role.Intel_Gatherer, Role.Area_Denial, Role.Anti_Roam], 1, Squad.Nighthaven),
	new Operator('Thunderbird', Gender.female, Side.defender, [Role.Secure, Role.Roam, Role.Buff], 2, Squad.Wolfguard),
	new Operator('Flores', Gender.male, Side.attacker, [Role.Disable, Role.Soft_Breach, Role.Area_Denial, Role.Back_Line], 2, Squad.Ghosteyes),
	new Operator('Aruni', Gender.female, Side.defender, [Role.Intel_Gatherer, Role.Secure, Role.Anchor], 1, Squad.Nighthaven),
	new Operator('Zero', Gender.male, Side.attacker, [Role.Intel_Denier, Role.Intel_Gatherer], 3, Squad.Ghosteyes),
	new Operator('Ace', Gender.male, Side.attacker, [Role.Front_Line, Role.Hard_Breach], 2, Squad.Nighthaven),
	new Operator('Melusi', Gender.female, Side.defender, [Role.Intel_Gatherer, Role.Secure, Role.Crowd_Control], 1, Squad.Wolfguard),
	new Operator('Oryx', Gender.male, Side.defender, [Role.Roam, Role.Soft_Breach], 2, Squad.Rainbow),
	new Operator('Iana', Gender.female, Side.attacker, [Role.Intel_Denier, Role.Intel_Gatherer], 2, Squad.Ghosteyes),
	new Operator('Wamai', Gender.male, Side.defender, [Role.Anchor, Role.Secure], 2, Squad.Nighthaven),
	new Operator('Kali', Gender.female, Side.attacker, [Role.Back_Line, Role.Covering_Fire, Role.Disable], 2, Squad.Nighthaven),
	new Operator('Amaru', Gender.female, Side.attacker, [Role.Front_Line, Role.Flank], 2, Squad.Rainbow),
	new Operator('Goyo', Gender.male, Side.defender, [Role.Area_Denial, Role.Secure], 2, Squad.Rainbow),
	new Operator('Nøkk', Gender.female, Side.attacker, [Role.Intel_Denier, Role.Flank], 2, Squad.Ghosteyes),
	new Operator('Warden', Gender.male, Side.defender, [Role.Anchor, Role.Intel_Denier], 2, Squad.Ghosteyes),
	new Operator('Mozzie', Gender.male, Side.defender, [Role.Intel_Gatherer, Role.Intel_Denier, Role.Secure], 2, Squad.Ghosteyes),
	new Operator('Gridlock', Gender.female, Side.attacker, [Role.Anti_Roam, Role.Area_Denial, Role.Crowd_Control], 1, Squad.Rainbow),
	new Operator('Nomad', Gender.female, Side.attacker, [Role.Anti_Roam, Role.Trap, Role.Crowd_Control], 2, Squad.Wolfguard),
	new Operator('Kaid', Gender.male, Side.defender, [Role.Anti_Hard_Breach, Role.Secure, Role.Anchor], 1, Squad.Rainbow),
	new Operator('Clash', Gender.female, Side.defender, [Role.Crowd_Control, Role.Intel_Gatherer, Role.Secure, Role.Shield], 1, Squad.Wolfguard),
	new Operator('Maverick', Gender.male, Side.attacker, [Role.Hard_Breach, Role.Back_Line, Role.Disable, Role.Flank], 3, Squad.Ghosteyes),
	new Operator('Maestro', Gender.male, Side.defender, [Role.Secure, Role.Anchor, Role.Area_Denial, Role.Intel_Gatherer], 1, Squad.Rainbow),
	new Operator('Alibi', Gender.female, Side.defender, [Role.Intel_Denier, Role.Intel_Gatherer, Role.Roam, Role.Trap], 3, Squad.Rainbow),
	new Operator('Lion', Gender.male, Side.attacker, [Role.Intel_Gatherer, Role.Back_Line, Role.Anti_Roam, Role.Crowd_Control], 2, Squad.Wolfguard),
	new Operator('Finka', Gender.female, Side.attacker, [Role.Back_Line, Role.Buff], 2, Squad.Nighthaven),
	new Operator('Vigil', Gender.male, Side.defender, [Role.Intel_Denier, Role.Roam], 3, Squad.Ghosteyes),
	new Operator('Dokkaebi', Gender.female, Side.attacker, [Role.Intel_Gatherer, Role.Intel_Denier, Role.Anti_Roam, Role.Flank], 3, Squad.Rainbow),
	new Operator(
		'Zofia',
		Gender.female,
		Side.attacker,
		[Role.Anti_Roam, Role.Crowd_Control, Role.Disable, Role.Flank, Role.Soft_Breach],
		1,
		Squad.Ghosteyes
	),
	new Operator('Ela', Gender.female, Side.defender, [Role.Crowd_Control, Role.Trap, Role.Roam], 2, Squad.Nighthaven),
	new Operator('Ying', Gender.female, Side.attacker, [Role.Crowd_Control, Role.Front_Line], 2, Squad.Wolfguard),
	new Operator(
		'Lesion',
		Gender.male,
		Side.defender,
		[Role.Crowd_Control, Role.Trap, Role.Roam, Role.Anchor, Role.Intel_Gatherer],
		2,
		Squad.Ghosteyes
	),
	new Operator('Mira', Gender.female, Side.defender, [Role.Secure, Role.Anchor, Role.Intel_Gatherer], 1, Squad.Rainbow),
	new Operator('Jackal', Gender.male, Side.attacker, [Role.Anti_Roam, Role.Intel_Gatherer], 2, Squad.Rainbow),
	new Operator('Hibana', Gender.female, Side.attacker, [Role.Hard_Breach, Role.Back_Line, Role.Front_Line], 3, Squad.Rainbow),
	new Operator('Echo', Gender.male, Side.defender, [Role.Anchor, Role.Crowd_Control, Role.Intel_Gatherer, Role.Secure], 2, Squad.Rainbow),
	new Operator('Caveira', Gender.female, Side.defender, [Role.Intel_Denier, Role.Intel_Gatherer, Role.Roam], 3, Squad.Ghosteyes),
	new Operator('Capitão', Gender.male, Side.attacker, [Role.Area_Denial, Role.Flank, Role.Front_Line], 3, Squad.Rainbow),
	new Operator('Blackbeard', Gender.male, Side.attacker, [Role.Back_Line, Role.Covering_Fire, Role.Shield], 2, Squad.Rainbow),
	new Operator('Valkyrie', Gender.female, Side.defender, [Role.Intel_Gatherer, Role.Roam], 2, Squad.Ghosteyes),
	new Operator('Buck', Gender.male, Side.attacker, [Role.Flank, Role.Soft_Breach], 2, Squad.Rainbow),
	new Operator('Frost', Gender.female, Side.defender, [Role.Crowd_Control, Role.Trap], 2, Squad.Wolfguard),
	new Operator('Mute', Gender.male, Side.defender, [Role.Anti_Hard_Breach, Role.Secure, Role.Intel_Denier], 1, Squad.Rainbow),
	new Operator('Sledge', Gender.male, Side.attacker, [Role.Flank, Role.Soft_Breach], 1, Squad.Rainbow),
	new Operator('Smoke', Gender.male, Side.defender, [Role.Anchor, Role.Secure, Role.Area_Denial], 2, Squad.Nighthaven),
	new Operator('Thatcher', Gender.male, Side.attacker, [Role.Back_Line, Role.Disable], 1, Squad.Rainbow),
	new Operator('Ash', Gender.female, Side.attacker, [Role.Flank, Role.Front_Line, Role.Disable, Role.Soft_Breach], 3, Squad.Rainbow),
	new Operator('Castle', Gender.male, Side.defender, [Role.Anchor, Role.Secure], 2, Squad.Wolfguard),
	new Operator('Pulse', Gender.male, Side.defender, [Role.Intel_Gatherer, Role.Roam], 3, Squad.Nighthaven),
	new Operator('Thermite', Gender.male, Side.attacker, [Role.Hard_Breach, Role.Back_Line], 2, Squad.Rainbow),
	new Operator('Montagne', Gender.male, Side.attacker, [Role.Shield], 1, Squad.Wolfguard),
	new Operator('Twitch', Gender.female, Side.attacker, [Role.Back_Line, Role.Disable, Role.Front_Line, Role.Intel_Gatherer], 2, Squad.Wolfguard),
	new Operator('Doc', Gender.male, Side.defender, [Role.Anchor, Role.Buff], 1, Squad.Wolfguard),
	new Operator('Rook', Gender.male, Side.defender, [Role.Anchor, Role.Buff], 1, Squad.Rainbow),
	new Operator('Jäger', Gender.male, Side.defender, [Role.Roam, Role.Secure], 2, Squad.Rainbow),
	new Operator('Bandit', Gender.male, Side.defender, [Role.Anti_Hard_Breach, Role.Roam, Role.Secure], 3, Squad.Wolfguard),
	new Operator('Blitz', Gender.male, Side.attacker, [Role.Anti_Roam, Role.Crowd_Control, Role.Front_Line, Role.Shield], 2, Squad.Rainbow),
	new Operator('IQ', Gender.female, Side.attacker, [], 3, Squad.Rainbow)
];

export { operators };
